package ru.dbotthepony.kstarbound.lua

/* thread status */
// #define LUA_OK		0
// #define LUA_YIELD	1
// #define LUA_ERRRUN	2
// #define LUA_ERRSYNTAX	3
// #define LUA_ERRMEM	4
// #define LUA_ERRERR	5

const val LUA_OK = 0
const val LUA_YIELD = 1
const val LUA_ERRRUN = 2
const val LUA_ERRSYNTAX = 3
const val LUA_ERRMEM = 4
const val LUA_ERRERR = 5

class InvalidLuaSyntaxException(message: String? = null, cause: Throwable? = null) : Throwable(message, cause)
class LuaMemoryAllocException(message: String? = null, cause: Throwable? = null) : Throwable(message, cause)
class LuaGCException(message: String? = null, cause: Throwable? = null) : Throwable(message, cause)
class LuaException(message: String? = null, cause: Throwable? = null) : Throwable(message, cause)
class LuaRuntimeException(message: String? = null, cause: Throwable? = null) : Throwable(message, cause)

fun throwLoadError(code: Int) {
	when (code) {
		LUA_OK -> {}
		LUA_ERRSYNTAX -> throw InvalidLuaSyntaxException()
		LUA_ERRMEM -> throw LuaMemoryAllocException()
		// LUA_ERRGCMM -> throw LuaGCException()
		else -> throw LuaException("Unknown Lua Loading error: $code")
	}
}

fun throwPcallError(code: Int) {
	when (code) {
		LUA_OK -> {}
		LUA_ERRRUN -> throw LuaException("Runtime Error")
		LUA_ERRMEM -> throw LuaMemoryAllocException()
		LUA_ERRERR -> throw LuaException("Exception inside Exception handler")
		else -> throw LuaException("Unknown Lua Loading error: $code")
	}
}
